# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Redis.V1.Model.Entitlement do
  @moduledoc """
  Proto representing the access that a user has to a specific feature/service. NextId: 3.

  ## Attributes

  *   `entitlementState` (*type:* `String.t`, *default:* `nil`) - The current state of user's accessibility to a feature/benefit.
  *   `type` (*type:* `String.t`, *default:* `nil`) - An enum that represents the type of this entitlement.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :entitlementState => String.t() | nil,
          :type => String.t() | nil
        }

  field(:entitlementState)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.Redis.V1.Model.Entitlement do
  def decode(value, options) do
    GoogleApi.Redis.V1.Model.Entitlement.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Redis.V1.Model.Entitlement do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
