# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Redis.V1beta1.Model.CertificateAuthority do
  @moduledoc """
  Redis cluster certificate authority

  ## Attributes

  *   `managedServerCa` (*type:* `GoogleApi.Redis.V1beta1.Model.ManagedCertificateAuthority.t`, *default:* `nil`) - 
  *   `name` (*type:* `String.t`, *default:* `nil`) - Identifier. Unique name of the resource in this scope including project, location and cluster using the form: `projects/{project}/locations/{location}/clusters/{cluster}/certificateAuthority`
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :managedServerCa => GoogleApi.Redis.V1beta1.Model.ManagedCertificateAuthority.t() | nil,
          :name => String.t() | nil
        }

  field(:managedServerCa, as: GoogleApi.Redis.V1beta1.Model.ManagedCertificateAuthority)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.Redis.V1beta1.Model.CertificateAuthority do
  def decode(value, options) do
    GoogleApi.Redis.V1beta1.Model.CertificateAuthority.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Redis.V1beta1.Model.CertificateAuthority do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
