# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Redis.V1beta1.Model.DatabaseMetadata do
  @moduledoc """
  Metadata for individual databases created in an instance. i.e. spanner instance can have multiple databases with unique configuration settings.

  ## Attributes

  *   `backupConfiguration` (*type:* `GoogleApi.Redis.V1beta1.Model.BackupConfiguration.t`, *default:* `nil`) - Backup configuration for this database
  *   `backupRun` (*type:* `GoogleApi.Redis.V1beta1.Model.BackupRun.t`, *default:* `nil`) - Information about the last backup attempt for this database
  *   `product` (*type:* `GoogleApi.Redis.V1beta1.Model.Product.t`, *default:* `nil`) - 
  *   `resourceId` (*type:* `GoogleApi.Redis.V1beta1.Model.DatabaseResourceId.t`, *default:* `nil`) - 
  *   `resourceName` (*type:* `String.t`, *default:* `nil`) - Required. Database name. Resource name to follow CAIS resource_name format as noted here go/condor-common-datamodel
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :backupConfiguration => GoogleApi.Redis.V1beta1.Model.BackupConfiguration.t() | nil,
          :backupRun => GoogleApi.Redis.V1beta1.Model.BackupRun.t() | nil,
          :product => GoogleApi.Redis.V1beta1.Model.Product.t() | nil,
          :resourceId => GoogleApi.Redis.V1beta1.Model.DatabaseResourceId.t() | nil,
          :resourceName => String.t() | nil
        }

  field(:backupConfiguration, as: GoogleApi.Redis.V1beta1.Model.BackupConfiguration)
  field(:backupRun, as: GoogleApi.Redis.V1beta1.Model.BackupRun)
  field(:product, as: GoogleApi.Redis.V1beta1.Model.Product)
  field(:resourceId, as: GoogleApi.Redis.V1beta1.Model.DatabaseResourceId)
  field(:resourceName)
end

defimpl Poison.Decoder, for: GoogleApi.Redis.V1beta1.Model.DatabaseMetadata do
  def decode(value, options) do
    GoogleApi.Redis.V1beta1.Model.DatabaseMetadata.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Redis.V1beta1.Model.DatabaseMetadata do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
