# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.Redis.V1beta1.Model.DiscoveryEndpoint do
  @moduledoc """
  Endpoints on each network, for Redis clients to connect to the cluster.

  ## Attributes

  *   `address` (*type:* `String.t`, *default:* `nil`) - Output only. Address of the exposed Redis endpoint used by clients to connect to the service. The address could be either IP or hostname.
  *   `port` (*type:* `integer()`, *default:* `nil`) - Output only. The port number of the exposed Redis endpoint.
  *   `pscConfig` (*type:* `GoogleApi.Redis.V1beta1.Model.PscConfig.t`, *default:* `nil`) - Output only. Customer configuration for where the endpoint is created and accessed from.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :address => String.t() | nil,
          :port => integer() | nil,
          :pscConfig => GoogleApi.Redis.V1beta1.Model.PscConfig.t() | nil
        }

  field(:address)
  field(:port)
  field(:pscConfig, as: GoogleApi.Redis.V1beta1.Model.PscConfig)
end

defimpl Poison.Decoder, for: GoogleApi.Redis.V1beta1.Model.DiscoveryEndpoint do
  def decode(value, options) do
    GoogleApi.Redis.V1beta1.Model.DiscoveryEndpoint.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.Redis.V1beta1.Model.DiscoveryEndpoint do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
